<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div class="modal-header">
    <h4
      class="modal-title"
      id="modal-basic-title"
      [innerText]="!!metadata.id ? messages.METADATA_EDIT_POPUP_TITLE : messages.METADATA_CREATION_POPUP_TITLE">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body">

    <form
      [formGroup]="generalForm"
      class="mt-4 mx-3 ls-form"
      novalidate>

      <div class="form-group required">
        <label
          class="w-100 required d-flex justify-content-between"
          for="keyInput">
          <span [innerText]="commonMessages.KEY"></span>
          <span
            *ngIf="!(metadata.id)"
            class="ls-info-label fw-normal"
            [innerText]="commonMessages.getMinDescriptionLabelInfo(2)">
          </span>
        </label>
        <input
          id="keyInput"
          formControlName="keyControl"
          [(ngModel)]="metadata.key"
          [autofocus]="!metadata?.key"
          type="text"
          class="form-control">
        <div
          *ngIf="!(metadata.id)"
          class="mt-3 alert alert-info"
          role="alert">
          <fa-icon
            class="pe-2"
            [icon]="infoIcon">
          </fa-icon>
          {{ messages.METADATA_ID_INFO }}
        </div>
      </div>

      <div class="form-group required">
        <label
          class="w-100 required d-flex justify-content-between"
          for="nameInput">
          <span [innerText]="commonMessages.NAME"></span>
          <span
            *ngIf="!(metadata.id)"
            class="ls-info-label fw-normal"
            [innerText]="commonMessages.getMinDescriptionLabelInfo(2)">
          </span>
        </label>
        <input
          id="nameInput"
          formControlName="nameControl"
          [(ngModel)]="metadata.name"
          [autofocus]="!!metadata?.key"
          type="text"
          class="form-control">
      </div>

      <div class="row">

        <div class="col-6 form-group">
          <label
            for="typeSelect"
            class="required"
            [innerText]="messages.METADATA_TYPE">
          </label>
          <select
            id="typeSelect"
            formControlName="typeControl"
            class="form-control selectpicker"
            [(ngModel)]="metadata.type"
            (ngModelChange)="onTypeChange()">
            <option
              *ngFor="let metadataType of metadataTypeEnum | keyvalue"
              [ngValue]="metadataType.value"
              [innerText]="metadataType.value | metadataTypeName">
            </option>
          </select>
        </div>

        <ng-template #indexTooltip>
          <div
            class="text-start"
            [innerText]="messages.INDEX_TOOLTIP">
          </div>
        </ng-template>

        <div class="col-6 form-group">
          <label for="indexInput">
            <span [innerText]="messages.INDEX"></span>
            <fa-icon
              class="ms-2"
              [icon]="infoIcon"
              [ngbTooltip]="indexTooltip">
            </fa-icon>
          </label>
          <input
            id="indexInput"
            formControlName="indexControl"
            [(ngModel)]="metadata.index"
            class="form-control"
            type="number">
        </div>

      </div>

      <div
        class="form-group"
        *ngIf="metadata.type !== metadataTypeEnum.Boolean">
        <div class="custom-control custom-checkbox">
          <input
            id="areValuesRestrictedCheckbox"
            class="custom-control-input"
            type="checkbox"
            [(ngModel)]="areValuesRestricted"
            (change)="updateValueAndValidity(generalForm)"
            [ngModelOptions]="{standalone: true}">
          <label
            class="custom-control-label"
            for="areValuesRestrictedCheckbox"
            [innerText]="messages.LIMIT_ALLOWED_VALUES">
          </label>
        </div>
      </div>

      <div
        class="form-group"
        *ngIf="areValuesRestricted && (metadata.type !== metadataTypeEnum.Boolean)">

        <div
          id="restrictedValues"
          (cdkDropListDropped)="onDrop($event)"
          cdkDropList>

          <div class="restricted-values-container-boundary">

            <div
              *ngFor="let _ of metadata.restrictedValues; let i = index; trackBy: trackByIndexFn"
              [attr.data-index]="i"
              class="py-1 px-2 bg-white d-flex flex-row"
              cdkDragLockAxis="y"
              cdkDragBoundary=".restricted-values-container-boundary"
              cdkDrag>

              <fa-icon
                class="align-self-center text-secondary p-2"
                [icon]="gripHorizontalIcon"
                cdkDragHandle>
              </fa-icon>

              <app-metadata-input
                class="flex-grow-1"
                id="metadataRestrictedValue{{ i }}"
                [type]="metadata.type"
                [editable]="true"
                [mandatory]="true"
                [(value)]="metadata.restrictedValues[i]"
                (valueChange)="updateValueAndValidity(generalForm)">
              </app-metadata-input>

              <button
                type="button"
                class="ms-2 btn btn-sm btn-outline-danger"
                [title]="commonMessages.DELETE"
                (click)="onDeleteValueButtonClicked(i)">
                <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
              </button>
            </div>

          </div>

          <div class="py-1">
            <button
              type="button"
              class="btn btn-sm btn-outline-primary"
              (click)="onAddValueButtonClicked()">
              <fa-icon
                class="pe-1"
                [icon]="commonIcons.ADD_ICON"></fa-icon>
              {{ messages.ADD_VALUE }}
            </button>
            <button
              type="button"
              class="ms-2 btn btn-sm btn-outline-secondary"
              (click)="onSortValuesButtonClicked()">
              <fa-icon
                class="pe-1"
                [icon]="sortIcon">
              </fa-icon>
              {{ messages.SORT }}
            </button>
          </div>

        </div>
      </div>

    </form>

  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
    <button
      ls-button-save
      [processing]="isProcessing"
      [disabled]="!generalForm.valid"
      (click)="validate()"
      [icon]="commonIcons.SAVE_ICON">
    </button>
  </div>

</div>
